﻿using System;
using System.Data.SqlClient;
using System.IO;
using System.Globalization;
using System.Transactions;
using Microsoft.Data.SqlRemoteBlobs;

namespace Program
{
    public class TestRemoteBlobStorage
    {
        private static byte[] WriteBlobPush(string sFile, string sConn)
        {
            byte[] blobId = null;

            using (TransactionScope ts = new TransactionScope(TransactionScopeOption.Required, TimeSpan.FromMinutes(10)))
            {
                //Open the connection to the database, Create and write the BLOB.
                using (SqlConnection conn = new SqlConnection(sConn))
                {
                    conn.Open();

                    SqlRemoteBlobContext blobContext = new SqlRemoteBlobContext(conn);
                    using (SqlRemoteBlob blob = blobContext.CreateNewBlob())
                    {
                        using (FileStream fileToRead = new FileStream(sFile, FileMode.Open))
                        {
                            blob.WriteFromStream(fileToRead);
                        }


                        //Update the application user table with the
                        //returned BLOB id and the filename.
                        using (SqlCommand cmd = new SqlCommand(string.Format(CultureInfo.InvariantCulture,
                            "INSERT INTO BlobUserTable(id, FileName, BlobId) Values('{0}', '{1}', @blobId)",
                            Guid.NewGuid(), sFile)))
                        {
                            cmd.Parameters.Add(new SqlParameter("@blobId", blob.GetBlobId()));
                            cmd.Connection = conn;
                            cmd.ExecuteNonQuery();
                        }
                    }
                    ts.Complete();
                }
            }
            return blobId;
        }

        static int Main(string[] args)
        {
            string sSqlServer = ".";
            string sRBSDatabase = "ContentDB";

            string sConnection = string.Format(CultureInfo.InvariantCulture,
                "Data Source={0};Initial Catalog={1};Integrated Security=SSPI",
                sSqlServer, sRBSDatabase);

            byte[] blobId = WriteBlobPush(@"c:\temp\myPicture.jpg", sConnection);

            return 0;
        }
    }
}
